<!--
 * @Descripttion: (店铺商品类目/tb_shop_goods_category 编辑弹窗)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-06-15)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-06-15)
-->
<template>
  <el-dialog v-model="props.modelValue" title="修改商品类目信息" width="600px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">
      <el-row v-if="userid == 1">
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="店铺" prop="shopGuid">
            <el-input v-model='formData.shopName' disabled type="text"></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row :gutter="20">

        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="上级类目" prop="ShopGoodsCategoryParentGuid">
            <el-cascader class="w100" :options="dataList"
              :props="{ checkStrictly: true, value: 'shopGoodsCategoryGuid', label: 'shopGoodsCategoryName', emitPath: false }"
              placeholder="请选择上级类目" clearable v-model="formData.shopGoodsCategoryParentGuid">
              <template #default="{ node, data }">
                <span>{{ data.shopGoodsCategoryName }}</span>
                <span v-if="!node.isLeaf"> ({{ data.children.length }}) </span>
              </template>
            </el-cascader>
          </el-form-item>
        </el-col>
      </el-row>


      <el-row>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="名称" prop="shopGoodsCategoryName">
            <el-input v-model="formData.shopGoodsCategoryName" placeholder="请输入名称" />
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="显示状态" prop="shopGoodsCategoryDisplayStatus">
            <el-radio-group v-model="formData.shopGoodsCategoryDisplayStatus">
              <el-radio v-for="item in  display_status " :key="item.dictValue" :label="parseInt(item.dictValue)">{{
                item.dictLabel }}</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="排序" prop="shopGoodsCategorySort">
            <el-input-number v-model.number="formData.shopGoodsCategorySort" controls-position="right" :min="0" />
          </el-form-item>
        </el-col>

      </el-row>
    </el-form>

    <template #footer>
      <div class="dialog-footer">
        <el-button type="primary" @click="handleEditClick(formRef)">编辑</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
      </div>
    </template>
  </el-dialog>
</template>

<script setup>
import { ElMessage } from 'element-plus'
import modal from '@/plugins/modal.js'
import { reactive, ref, watch } from "vue";
import useUserStore from '@/store/modules/user'
import { shopGoodsCategoryTreeList, addOrUpdateShopGoodsCategory } from "@/api/business/GoodsManager/ShopGoodsCategorys/shopGoodsCategory.js";


// 打开弹窗时回调
const openDialog = async () => {
  await getdisplay_status()

  await getTreeList()
}

const formData = ref({
  ...props.data,
});
watch(props, async (v) => {
  formData.value = v.data;

});

// 业务参数
const userid = useUserStore().userId
const dataList = ref([])
// 显示状态字典选项列表
const display_status = ref([]);

// -业务方法
//字典获取
async function getdisplay_status() {
  await proxy.getDicts('display_status').then((res) => {
    display_status.value = res.data
  })
}



// -基础参数
const props = defineProps({
  modelValue: Boolean,
  data: Object,
  done: Function,
});

const labelWidth = 100;
const formRef = ref();
const { proxy } = getCurrentInstance()
const emits = defineEmits(["update:modelValue"]);
const imgData = ref({
  fileDir: "ShopGoodsCategory"
})

// 验证
const rules = reactive({
  shopGoodsCategoryParentGuid: [{ required: true, message: "上级菜单不能为空", trigger: "blur", type: "number" }],
  shopGoodsCategoryName: [{ required: true, message: "名称不能为空", trigger: "blur" }],
  shopGoodsCategoryDisplayStatus: [{ required: true, message: "显示状态不能为空", trigger: "blur", type: "number" }],
  shopGoodsCategorySort: [{ required: true, message: "排序不能为空", trigger: "blur", type: "number" }],
});

// -基础方法
async function getTreeList() {
  shopGoodsCategoryTreeList().then((res) => {
    if (res.code == 200) {
      dataList.value = res.data
    }
  })
}
// 提交
const handleEditClick = async (formEl) => {
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }


    const { code } = await addOrUpdateShopGoodsCategory(formData.value);
    if (code == 200) {
      modal.msgSuccess('修改成功')
      closeDialog();
    }
  });
}

const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
}
const closeDialog = () => {
  props.done();
  emits("update:modelValue", false);
};

</script>
